/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.kaki.client.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.eof.EOLolfNomenclatureDepense;
import org.cocktail.application.client.eof.EOOrgan;
import org.cocktail.application.client.eof.EOTypeCredit;
import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableCellRenderer;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.application.common.utilities.CocktailFormats;
import org.cocktail.kaki.client.metier.EOCodeAnalytique;
import org.cocktail.kaki.client.metier.EOConvention;
import org.cocktail.kaki.client.metier.EOKx10ElementLbud;
import org.cocktail.kaki.common.KakiConstantes;
import org.cocktail.kaki.common.KakiIcones;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class AffichageBSView extends javax.swing.JDialog {

     /**
	 * 
	 */
	private static final long serialVersionUID = -6138851415438251978L;
	protected EODisplayGroup eod, eodLbud;
	protected ZEOTable myEOTable, myEOTableLbud;
	protected ZEOTableModel myTableModel, myTableModelLbud;
	protected TableSorter myTableSorter, myTableSorterLbud;
	
	private CellEditor myCellEditor = new CellEditor(new JTextField());

	ZEOTableModelColumn.Modifier salarialModifier;
	ZEOTableCellRenderer myRenderer;

    /** Creates new form AffichageBSView */
    public AffichageBSView(java.awt.Frame parent, boolean modal, EODisplayGroup myEod, EODisplayGroup myEodLbud, 
    		ZEOTableCellRenderer renderer, ZEOTableModelColumn.Modifier modifier) {
        super(parent, modal);

        eod = myEod;
        eodLbud = myEodLbud;
        
        salarialModifier = modifier;
        
        myRenderer = renderer;

        initComponents();
        
        initGui();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        tfTitre = new javax.swing.JTextField();
        viewTable = new javax.swing.JPanel();
        tfImputation = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        buttonGetClasse6 = new javax.swing.JButton();
        buttonDelClasse6 = new javax.swing.JButton();
        buttonClose = new javax.swing.JButton();
        buttonGetLbud = new javax.swing.JButton();
        buttonUpdateLbud = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        viewTableLbud = new javax.swing.JPanel();
        buttonDelElement = new javax.swing.JButton();
        buttonDelLbud = new javax.swing.JButton();
        buttonCharges = new javax.swing.JButton();
        btnAssocierCharges = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        tfTitre.setBackground(new java.awt.Color(255, 255, 204));
        tfTitre.setEditable(false);
        tfTitre.setFont(new java.awt.Font("Times New Roman", 1, 12));
        tfTitre.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        tfTitre.setText("KARIM ALLAF - BS DE SEPTEMBRE 2008");
        tfTitre.setAutoscrolls(false);
        tfTitre.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        tfTitre.setFocusable(false);
        tfTitre.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tfTitreActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout viewTableLayout = new org.jdesktop.layout.GroupLayout(viewTable);
        viewTable.setLayout(viewTableLayout);
        viewTableLayout.setHorizontalGroup(
            viewTableLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 755, Short.MAX_VALUE)
        );
        viewTableLayout.setVerticalGroup(
            viewTableLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 392, Short.MAX_VALUE)
        );

        tfImputation.setBackground(new java.awt.Color(204, 204, 204));
        tfImputation.setEditable(false);
        tfImputation.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tfImputationActionPerformed(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel1.setText("Imputation Manuelle :");

        buttonGetClasse6.setMaximumSize(new java.awt.Dimension(75, 75));
        buttonGetClasse6.setMinimumSize(new java.awt.Dimension(30, 22));
        buttonGetClasse6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonGetClasse6ActionPerformed(evt);
            }
        });

        buttonDelClasse6.setMaximumSize(new java.awt.Dimension(75, 75));
        buttonDelClasse6.setMinimumSize(new java.awt.Dimension(30, 22));
        buttonDelClasse6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonDelClasse6ActionPerformed(evt);
            }
        });

        buttonClose.setText("Fermer");
        buttonClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCloseActionPerformed(evt);
            }
        });

        buttonGetLbud.setMaximumSize(new java.awt.Dimension(75, 75));
        buttonGetLbud.setMinimumSize(new java.awt.Dimension(30, 22));
        buttonGetLbud.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonGetLbudActionPerformed(evt);
            }
        });

        buttonUpdateLbud.setMaximumSize(new java.awt.Dimension(75, 75));
        buttonUpdateLbud.setMinimumSize(new java.awt.Dimension(30, 22));
        buttonUpdateLbud.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonUpdateLbudActionPerformed(evt);
            }
        });

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText("Ligne Budgétaire :");

        viewTableLbud.setLayout(new java.awt.BorderLayout());

        buttonDelElement.setMaximumSize(new java.awt.Dimension(75, 75));
        buttonDelElement.setMinimumSize(new java.awt.Dimension(30, 22));
        buttonDelElement.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonDelElementActionPerformed(evt);
            }
        });

        buttonDelLbud.setMaximumSize(new java.awt.Dimension(75, 75));
        buttonDelLbud.setMinimumSize(new java.awt.Dimension(30, 22));
        buttonDelLbud.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonDelLbudActionPerformed(evt);
            }
        });

        buttonCharges.setToolTipText("Calcul automatique de la quotité de l'élément sélectionné");
        buttonCharges.setMaximumSize(new java.awt.Dimension(75, 75));
        buttonCharges.setMinimumSize(new java.awt.Dimension(30, 22));
        buttonCharges.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonChargesActionPerformed(evt);
            }
        });

        btnAssocierCharges.setToolTipText("Calcul automatique de la quotité de l'élément sélectionné");
        btnAssocierCharges.setMaximumSize(new java.awt.Dimension(75, 75));
        btnAssocierCharges.setMinimumSize(new java.awt.Dimension(30, 22));
        btnAssocierCharges.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAssocierChargesActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tfTitre, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 775, Short.MAX_VALUE)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(jLabel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 115, Short.MAX_VALUE)
                    .add(jLabel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 115, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(viewTableLbud, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 537, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(buttonUpdateLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 33, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(buttonGetLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 33, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(buttonDelLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 33, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(layout.createSequentialGroup()
                                .add(buttonCharges, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 33, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(btnAssocierCharges, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 33, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                        .add(31, 31, 31))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(tfImputation, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 363, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonGetClasse6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 33, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonDelClasse6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 33, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(152, 152, 152)
                        .add(buttonDelElement, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 33, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())))
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap(646, Short.MAX_VALUE)
                .add(buttonClose, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 119, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(tfTitre, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 26, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(buttonGetClasse6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(tfImputation, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(buttonDelClasse6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(buttonDelElement, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel2)
                    .add(viewTableLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 113, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(buttonGetLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonUpdateLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(buttonDelLbud, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 16, Short.MAX_VALUE)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, btnAssocierCharges, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, buttonCharges, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 27, Short.MAX_VALUE))))
                .add(18, 18, 18)
                .add(buttonClose)
                .addContainerGap())
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-791)/2, (screenSize.height-675)/2, 791, 675);
    }// </editor-fold>//GEN-END:initComponents

    
    
    
public javax.swing.JButton getButtonClose() {
		return buttonClose;
	}

	public void setButtonClose(javax.swing.JButton buttonClose) {
		this.buttonClose = buttonClose;
	}

public javax.swing.JButton getButtonDelLbud() {
		return buttonDelLbud;
	}

	public void setButtonDelLbud(javax.swing.JButton buttonDelLbud) {
		this.buttonDelLbud = buttonDelLbud;
	}

	public javax.swing.JButton getButtonGetLbud() {
		return buttonGetLbud;
	}

	public javax.swing.JButton getBtnAssocierCharges() {
		return btnAssocierCharges;
	}

	public void setBtnAssocierCharges(javax.swing.JButton btnAssocierCharges) {
		this.btnAssocierCharges = btnAssocierCharges;
	}

	public void setButtonGetLbud(javax.swing.JButton buttonGetLbud) {
		this.buttonGetLbud = buttonGetLbud;
	}

public javax.swing.JButton getButtonCharges() {
		return buttonCharges;
	}

	public void setButtonCharges(javax.swing.JButton buttonCharges) {
		this.buttonCharges = buttonCharges;
	}

public javax.swing.JButton getButtonUpdateLbud() {
		return buttonUpdateLbud;
	}

	public void setButtonUpdateLbud(javax.swing.JButton buttonUpdateLbud) {
		this.buttonUpdateLbud = buttonUpdateLbud;
	}

public ZEOTable getMyEOTableLbud() {
		return myEOTableLbud;
	}

	public void setMyEOTableLbud(ZEOTable myEOTableLbud) {
		this.myEOTableLbud = myEOTableLbud;
	}

public javax.swing.JButton getButtonGetClasse6() {
		return buttonGetClasse6;
	}

	public void setButtonGetClasse6(javax.swing.JButton buttonGetClasse6) {
		this.buttonGetClasse6 = buttonGetClasse6;
	}

	public javax.swing.JTextField getTfImputation() {
		return tfImputation;
	}

	public void setTfImputation(javax.swing.JTextField tfImputation) {
		this.tfImputation = tfImputation;
	}

private void buttonCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCloseActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_buttonCloseActionPerformed


private void tfTitreActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tfTitreActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_tfTitreActionPerformed

private void tfImputationActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tfImputationActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_tfImputationActionPerformed

private void buttonGetClasse6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonGetClasse6ActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_buttonGetClasse6ActionPerformed

private void buttonDelClasse6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonDelClasse6ActionPerformed
// TODO add your handling code here:
}//GEN-LAST:event_buttonDelClasse6ActionPerformed

private void buttonGetLbudActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonGetLbudActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_buttonGetLbudActionPerformed

private void buttonUpdateLbudActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonUpdateLbudActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_buttonUpdateLbudActionPerformed

private void buttonDelElementActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonDelElementActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_buttonDelElementActionPerformed

private void buttonDelLbudActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonDelLbudActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_buttonDelLbudActionPerformed

private void buttonChargesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonChargesActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_buttonChargesActionPerformed

private void btnAssocierChargesActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAssocierChargesActionPerformed
    // TODO add your handling code here:
}//GEN-LAST:event_btnAssocierChargesActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                AffichageBSView dialog = new AffichageBSView(new javax.swing.JFrame(), true, null, null,null, null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    
    
    public javax.swing.JButton getButtonDelElement() {
		return buttonDelElement;
	}

	public void setButtonDelElement(javax.swing.JButton buttonDelElement) {
		this.buttonDelElement = buttonDelElement;
	}

	public javax.swing.JButton getButtonDelClasse6() {
		return buttonDelClasse6;
	}

	public void setButtonDelClasse6(javax.swing.JButton buttonDelClasse6) {
		this.buttonDelClasse6 = buttonDelClasse6;
	}



    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JButton btnAssocierCharges;
    protected javax.swing.JButton buttonCharges;
    private javax.swing.JButton buttonClose;
    protected javax.swing.JButton buttonDelClasse6;
    protected javax.swing.JButton buttonDelElement;
    protected javax.swing.JButton buttonDelLbud;
    protected javax.swing.JButton buttonGetClasse6;
    protected javax.swing.JButton buttonGetLbud;
    protected javax.swing.JButton buttonUpdateLbud;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    protected javax.swing.JTextField tfImputation;
    private javax.swing.JTextField tfTitre;
    protected javax.swing.JPanel viewTable;
    private javax.swing.JPanel viewTableLbud;
    // End of variables declaration//GEN-END:variables

    	/*
	 * (non-Javadoc)
	 * 
	 * @see fr.univlr.karukera.client.ZKarukeraPanel#initGUI()
	 */
	private void initGui() {
		
		buttonClose.setIcon(KakiIcones.ICON_CLOSE);		
		buttonGetClasse6.setIcon(KakiIcones.ICON_SELECT_16);		
		buttonDelClasse6.setIcon(KakiIcones.ICON_DELETE);		

		buttonGetLbud.setIcon(KakiIcones.ICON_ADD);		
		buttonUpdateLbud.setIcon(KakiIcones.ICON_UPDATE);
		buttonDelLbud.setIcon(KakiIcones.ICON_DELETE);

		buttonCharges.setIcon(KakiIcones.ICON_CALCULATE_16);		
		buttonCharges.setToolTipText("Pourcentage de charges associées");
		
		btnAssocierCharges.setIcon(KakiIcones.ICON_DUPLICATE);		
		btnAssocierCharges.setToolTipText("Etendre la ou les lignes budgétaires aux charges");

		buttonDelElement.setIcon(KakiIcones.ICON_DELETE);		

		Vector<ZEOTableModelColumn> myCols = new Vector<ZEOTableModelColumn>();
		
		ZEOTableModelColumn col = new ZEOTableModelColumn(eod, "CODE" , "Code", 65);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "LIBELLE", "Elément", 190);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "TYPE", "Type", 45);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "CONEX", "Conex", 45);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "BUDGET", "BUDGET", 75);
		col.setAlignment(SwingConstants.CENTER);
		col.setTableCellRenderer(myRenderer);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "PCO_NUM", "COMPTE 6", 60);
		col.setAlignment(SwingConstants.LEFT);
		col.setTableCellRenderer(myRenderer);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "REMUN", "REMUN", 75);
		col.setAlignment(SwingConstants.RIGHT);
		col.setTableCellRenderer(myRenderer);
		col.setFormatDisplay(CocktailFormats.FORMAT_DECIMAL);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "OUVRIER", "OUVRIER", 75);
		col.setAlignment(SwingConstants.RIGHT);
		col.setTableCellRenderer(myRenderer);
		col.setFormatDisplay(CocktailFormats.FORMAT_DECIMAL);
		col.setTableCellEditor(myCellEditor);			
  	    col.setMyModifier(salarialModifier);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "INFOS", "INFOS", 75);
		col.setAlignment(SwingConstants.RIGHT);
		col.setTableCellRenderer(myRenderer);
		col.setFormatDisplay(CocktailFormats.FORMAT_DECIMAL);
		col.setTableCellEditor(myCellEditor);			
		myCols.add(col);
        col = new ZEOTableModelColumn(eod, "CAT", "Cat", 50);
		col.setAlignment(SwingConstants.CENTER);
		col.setTableCellRenderer(myRenderer);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "COMPTE6", "6", 40);
		col.setAlignment(SwingConstants.LEFT);
		col.setTableCellRenderer(myRenderer);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, "COMPTE4", "4", 40);
		col.setAlignment(SwingConstants.LEFT);
		col.setTableCellRenderer(myRenderer);
		myCols.add(col);
		
		myTableModel = new ZEOTableModel(eod, myCols);
		myTableSorter = new TableSorter(myTableModel);

		myEOTable = new ZEOTable(myTableSorter);
		myTableSorter.setTableHeader(myEOTable.getTableHeader());		
		
		myEOTable.setBackground(KakiConstantes.COLOR_FOND_NOMENCLATURES);
		myEOTable.setSelectionBackground(KakiConstantes.COLOR_SELECTED_ROW);
		myEOTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);		
		
		viewTable.setBorder(BorderFactory.createEmptyBorder());
		viewTable.removeAll();
		viewTable.setLayout(new BorderLayout());
		viewTable.add(new JScrollPane(myEOTable), BorderLayout.CENTER);
	
		// LBUD		
		myCols = new Vector<ZEOTableModelColumn>();
		
		col = new ZEOTableModelColumn(eodLbud, EOKx10ElementLbud.ORGAN_KEY + "."+ EOOrgan.ORG_UB_KEY, "UB", 50);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodLbud, EOKx10ElementLbud.ORGAN_KEY + "."+ EOOrgan.ORG_CR_KEY, "CR", 75);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodLbud, EOKx10ElementLbud.ORGAN_KEY + "."+ EOOrgan.ORG_SOUSCR_KEY, "SOUS CR", 115);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodLbud, EOKx10ElementLbud.TYPE_CREDIT_KEY + "." + EOTypeCredit.TCD_CODE_KEY, "TCD", 40);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodLbud, EOKx10ElementLbud.LOLF_KEY+"."+EOLolfNomenclatureDepense.LOLF_CODE_KEY, "Action", 60);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodLbud, EOKx10ElementLbud.CODE_ANALYTIQUE_KEY +"." + EOCodeAnalytique.CAN_CODE_KEY, "Canal", 110);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodLbud, EOKx10ElementLbud.CONVENTION_KEY +"." + EOConvention.CON_INDEX_KEY, "Conv", 80);
		col.setAlignment(SwingConstants.LEFT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodLbud, EOKx10ElementLbud.KEL_QUOTITE_KEY, "Quot", 50);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodLbud, EOKx10ElementLbud.KEL_POURCENT_CHARGES_KEY, "Charges", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		
		myTableModelLbud = new ZEOTableModel(eodLbud, myCols);
		myTableSorterLbud = new TableSorter(myTableModelLbud);

		myEOTableLbud = new ZEOTable(myTableSorterLbud);
		myTableSorterLbud.setTableHeader(myEOTableLbud.getTableHeader());		
		
		myEOTableLbud.setBackground(KakiConstantes.COLOR_FOND_NOMENCLATURES);
		myEOTableLbud.setSelectionBackground(KakiConstantes.COLOR_SELECTED_ROW);
		myEOTableLbud.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);		
		
		viewTableLbud.setBorder(BorderFactory.createEmptyBorder());
		viewTableLbud.removeAll();
		viewTableLbud.setLayout(new BorderLayout());
		viewTableLbud.add(new JScrollPane(myEOTableLbud), BorderLayout.CENTER);

    }
	
	
	private final class CellEditor extends ZEOTableModelColumn.ZEONumFieldTableCellEditor {
		
		/**
		 * 
		 */
		private static final long serialVersionUID = -478474961685649403L;
		private  JTextField myTextField;
		
		public CellEditor(JTextField textField) {
			super(textField, CocktailFormats.FORMAT_DECIMAL);
		}
		
		public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
			
			myTextField = (JTextField) super.getTableCellEditorComponent(table, value, isSelected, row, column);
			
			myTextField.setBorder(BorderFactory.createLineBorder(Color.RED));	
			myTextField.setEditable(true);
			
			return myTextField;
		}
	}	
	

        
	public javax.swing.JTextField getTfTitre() {
		return tfTitre;
	}

	public void setTfTitre(javax.swing.JTextField tfTitre) {
		this.tfTitre = tfTitre;
	}

	public ZEOTable getMyEOTable() {
		return myEOTable;
	}

	public void setMyEOTable(ZEOTable myEOTable) {
		this.myEOTable = myEOTable;
	}
}
